function [y2,y3]=Calc_sal_TS_v3_sigma(TT,PP,lat,lon,timet)
%THIS FUNCTION CALCULATES THE SALINITY VIA A RELATIONSHIP
%WITH TEMPERATURE, PRESSURE, LAT, LON, YEAR, MONTH
%INPUT:
%TT - TEMPERATURE (2D FIELD) TT(DEPTH,POSITION);
%PP - PRESSURE (1-D FIELD) 
%LAT - LATITUDE (DEG) (2D FIELD) LAT(POSITION)
%LON - LONGITUDE (DEG)(2D FIELD) LON(POSITION)
%TIMET - TIME ( E.G.,200411(01) ) (1D FIELD) TIME(TIME) 

display('Contruct year, month arrays ...')

%Contruct year, month arrays
timet = timet(:);
timet(isnan(timet))=0;

%LOAD FITTED PARAMETERS
display('Load Fitted parameters ...')
sai = find(lat >=-70 & lat <-15 & lon >-75 & lon < 30);
    basin(sai,:) = repmat('SA',length(sai),1);
tai = find(lat >=-15 & lat <10 & lon>-80 & lon < 20);
    basin(tai,:) = repmat('TA',length(tai),1);
nai = find(lat >=10 & lat <65 & lon >-100 & lon < 30);
    basin(nai,:)  = repmat('NA',length(nai),1);

    [nz,nla1,nmo1]=size(TT);
   y2 = nan*ones(nz,nla1,nmo1);%size(TT));
 stnai = find([~isempty(tai) ~isempty(sai) ~isempty(nai)]);
    
%Divide data by basin
for bb = stnai %1:3
    
switch bb
    case 1
     display('Load TA')   
load fit_sigma_cora_argo_extended_algebra_TA.mat
ai = tai;
    case 2
     display('Load SA')   
load fit_sigma_cora_argo_extended_algebra_SA.mat
ai = sai;
    case 3
     display('Load NA')   
load fit_sigma_cora_argo_extended_algebra_NA.mat
ai = nai;
end

        T = TT(:,ai);
        P = PP(:);
longitude = lon(ai);
latitude  = lat(ai);
     time = timet(ai,:);
    alnan = time==0;

nt   = length(time);
time = num2str(time);

year  =  nan*ones(nt,1);
month =  nan*ones(nt,1);

year(~alnan)   = str2num(time(~alnan,1:4)); year(:) = 2014*ones(1,nt);
month(~alnan)  = str2num(time(~alnan,5:6));

nz  = length(P); 
nll = length(X(:));
[nz,nla,nmo]=size(T);
nv  = size(VEC,2);

display('All following sizes must be the same:')

yy = repmat(year',nz,1);   size(yy),     yy = yy(:);
mo = repmat(month',nz,1);  size(mo),     mo = mo(:);
pp = repmat(P,1,length(time)); size(pp), pp = pp(:);

latitude  = latitude(:);        
longitude = longitude(:); 
latitude  = repmat(latitude',nz,1); size(latitude); latitude=latitude(:); 
longitude = repmat(longitude',nz,1);size(longitude); longitude=longitude(:);
 
  T    = reshape(T,nz,nla*nmo);   size(T); t = T(:);
  
 aan = find(~isnan(t));   
   y = nan*ones(1, length(t));

   display('start loop...')
for aa = aan'%1:length(s)
    
dflat = abs(latitude(aa)-Y(:))+abs(longitude(aa)-X(:));

  [~,ll] = min(dflat);
  if dflat(ll) > 2,continue,end
   vec = VEC(ll,:);
      kk = find(t(aa) > vec(1:end-1) & t(aa) <=vec(2:end)); 
      
      if isempty(kk),continue,end
      
       xmean = squeeze(xmean_ii(ll,kk,:))';
       pp2 = log(pp(aa));
       a1 = t(aa)-xmean(1);
       a2 = pp2-xmean(2);
       a3 = a1.*a2;
       a4 = yy(aa)-xmean(4);
       a5 = cos(2*pi*mo(aa)/12) - xmean(5);
       a6 = sin(2*pi*mo(aa)/12) - xmean(6);
       a7 = cos(4*pi*mo(aa)/12) - xmean(7);
       a8 = sin(4*pi*mo(aa)/12) - xmean(8);
       x = [a1 a2 a3 a4 a5 a6 a7 a8];
y(aa) =  x * squeeze(beta_ii(ll,kk,:)).*ystd_ii(ll,kk,:) + ymean_ii(ll,kk);
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      if y(aa) > 42 || y(aa)<0;  y(aa) = ymean_ii(ll,kk);display('big');end
      if y(aa) > 42 || y(aa)<15; y(aa) = ymean_ii(ll,kk);display('big');end
      
      if y(aa)==0;y(aa)=nan;end
      
end
clear yy mo latitude longitude pp t

y2(:,ai)   = reshape(y,nz,nla);
end

%Median Filter For output y3%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
y3 = y2;
pai = find(P>2000);
nlon = size(y3,2);

for jj =1:nlon
    s2 = y3(:,jj);s3 = s2;
    acha2 = (~isnan(s2));
    if (nnz(acha2)>2 && nnz(acha2)<nz)
    s3(~acha2) = interp1(P(acha2),s2(acha2),P(~acha2),'nearest','extrap');
    tfilt2 = medfilt1(s3,7);
    y3(:,jj) = tfilt2;
    end
end

%ADD NAN's where T is nan and P > 2000
y3(pai,:)=nan;
y3(isnan(TT))=nan;                                                         
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear beta_ii xmean_ii ymean_ii

return
